#
# Conditional build:
%bcond_without	asio		# libnghttp2_asio C++ library
%bcond_without	static_libs	# static libraries
%bcond_without	tests		# "make check" call

Summary:	HTTP/2.0 C library
Summary(pl.UTF-8):	Biblioteka C HTTP/2.0
Name:		nghttp2
Version:	1.14.0
Release:	1
License:	MIT
Group:		Libraries
#Source0Download: https://github.com/nghttp2/nghttp2/releases
Source0:	https://github.com/nghttp2/nghttp2/releases/download/v%{version}/%{name}-%{version}.tar.xz
# Source0-md5:	e9f313abcc9d8e29093f196aeb4aaa2c
Patch0:		%{name}-link.patch
Patch1:		%{name}-python.patch
URL:		https://nghttp2.org/
%{?with_tests:BuildRequires:	CUnit >= 2.1}
BuildRequires:	autoconf >= 2.61
BuildRequires:	automake
%{?with_asio:BuildRequires:	boost-devel >= 1.54.0}
BuildRequires:	jansson-devel >= 2.5
BuildRequires:	libev-devel
BuildRequires:	libevent-devel >= 2.0.8
BuildRequires:	libstdc++-devel >= 6:4.3
BuildRequires:	libtool >= 2:2.2.6
BuildRequires:	libxml2-devel >= 1:2.7.7
BuildRequires:	openssl-devel >= 1.0.1
BuildRequires:	pkgconfig >= 1:0.20
BuildRequires:	python >= 1:2.7
BuildRequires:	python-Cython
BuildRequires:	python-setuptools
BuildRequires:	rpm-pythonprov
BuildRequires:	sed >= 4.0
BuildRequires:	spdylay-devel >= 1.3.2
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRequires:	zlib-devel >= 1.2.3
Requires:	%{name}-libs = %{version}-%{release}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# non-function symbols std::__once_call, std::__once_callable
%define		skip_post_check_so	libnghttp2_asio.so.*

%description
This is an experimental implementation of Hypertext Transfer Protocol
version 2.0.

%description -l pl.UTF-8
Ta biblioteka jest eksperymentalną implementacją protokołu HTTP
(Hypertext Transfer Protocol) w wersji 2.0.

%package libs
Summary:	A library implementing the HTTP/2 protocol
Summary(pl.UTF-8):	Biblioteka implementująca protokół HTTP/2
Group:		Libraries
Requires:	jansson >= 2.5
Requires:	libevent >= 2.0.8
Requires:	libxml2 >= 1:2.7.7
Requires:	openssl >= 1.0.1
Requires:	spdylay >= 1.3.2
Requires:	zlib >= 1.2.3
Conflicts:	nghttp2 < 1.11.1-2

%description libs
libnghttp2 is a library implementing the Hypertext Transfer Protocol
version 2 (HTTP/2) protocol in C.

%description libs -l pl.UTF-8
libnghttp2 to napisana w C biblioteka implementująca protokół HTTP/2
(Hypertext Transfer Protocol w wersji 2).

%package devel
Summary:	Files needed for developing with libnghttp2
Summary(pl.UTF-8):	Pliki niezbędne do tworzenia aplikacji z użyciem libnghttp2
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	zlib-devel >= 1.2.3

%description devel
Files needed for building applications with libnghttp2.

%description devel -l pl.UTF-8
Pliki niezbędne do tworzenia aplikacji z użyciem libnghttp2.

%package static
Summary:	Static libnghttp2 library
Summary(pl.UTF-8):	Statyczna biblioteka libnghttp2
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static libnghttp2 library.

%description static -l pl.UTF-8
Statyczna biblioteka libnghttp2.

%package -n python-nghttp2
Summary:	Python binding to nghttp2 library
Summary(pl.UTF-8):	Wiązanie Pythona do biblioteki nghttp2
Group:		Libraries/Python
Requires:	%{name} = %{version}-%{release}
Requires:	python-libs >= 1:2.7

%description -n python-nghttp2
Python binding to nghttp2 library.

%description -n python-nghttp2 -l pl.UTF-8
Wiązanie Pythona do biblioteki nghttp2.

%package asio
Summary:	HTTP/2.0 C++ library
Summary(pl.UTF-8):	Biblioteka C++ HTTP/2.0
Group:		Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	openssl >= 1.0.1

%description asio
HTTP/2.0 C++ library.

%description asio -l pl.UTF-8
Biblioteka C++ HTTP/2.0.

%package asio-devel
Summary:	Header file for nghttp2_asio library
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki nghttp2_asio
Group:		Development/Libraries
Requires:	%{name}-asio = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	libstdc++-devel

%description asio-devel
Header file for nghttp2_asio library.

%description asio-devel -l pl.UTF-8
Plik nagłówkowy biblioteki nghttp2_asio.

%package asio-static
Summary:	Static libnghttp2_asio library
Summary(pl.UTF-8):	Statyczna biblioteka libnghttp2_asio
Group:		Development/Libraries
Requires:	%{name}-asio-devel = %{version}-%{release}

%description asio-static
Static libnghttp2_asio library.

%description asio-static -l pl.UTF-8
Statyczna biblioteka libnghttp2_asio.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%{__sed} -i -e '1s,/usr/bin/env python,%{__python},' script/fetch-ocsp-response

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--enable-app \
	%{?with_asio:--enable-asio-lib} \
	--enable-hpack-tools \
	--enable-python-bindings \
	--disable-silent-rules \
	%{!?with_static_libs:--disable-static} \
	--without-jemalloc

%{__make}

%if %{with tests}
%{__make} check
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libnghttp2*.la
# packaged as %doc
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/nghttp2

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%post	asio -p /sbin/ldconfig
%postun	asio -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS COPYING ChangeLog README.rst
%attr(755,root,root) %{_bindir}/deflatehd
%attr(755,root,root) %{_bindir}/h2load
%attr(755,root,root) %{_bindir}/inflatehd
%attr(755,root,root) %{_bindir}/nghttp
%attr(755,root,root) %{_bindir}/nghttpd
%attr(755,root,root) %{_bindir}/nghttpx
%dir %{_datadir}/nghttp2
%attr(755,root,root) %{_datadir}/nghttp2/fetch-ocsp-response
%{_mandir}/man1/h2load.1*
%{_mandir}/man1/nghttp.1*
%{_mandir}/man1/nghttpd.1*
%{_mandir}/man1/nghttpx.1*

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libnghttp2.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libnghttp2.so.14

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libnghttp2.so
%dir %{_includedir}/nghttp2
%{_includedir}/nghttp2/nghttp2*.h
%{_pkgconfigdir}/libnghttp2.pc

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libnghttp2.a
%endif

%files -n python-nghttp2
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/nghttp2.so
%{py_sitedir}/python_nghttp2-%{version}-py*.egg-info

%if %{with asio}
%files asio
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libnghttp2_asio.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libnghttp2_asio.so.1

%files asio-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libnghttp2_asio.so
%{_includedir}/nghttp2/asio_http2.h
%{_includedir}/nghttp2/asio_http2_client.h
%{_includedir}/nghttp2/asio_http2_server.h
%{_pkgconfigdir}/libnghttp2_asio.pc

%if %{with static_libs}
%files asio-static
%defattr(644,root,root,755)
%{_libdir}/libnghttp2_asio.a
%endif
%endif
%changelog
* Tue Aug 30 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/nghttp2.git;a=log;h=master

* Tue Aug 30 2016 Jakub Bogusz <qboosh@pld-linux.org> a90b790
- updated to 1.14.0

* Wed Jun 29 2016 Jakub Bogusz <qboosh@pld-linux.org> 27bc50c
- new URLs, updated to 1.12.0
- pl for -libs

* Sun Jun 19 2016 Elan Ruusamäe <glen@delfi.ee> 218ea8d
- split -libs

* Wed Jun 15 2016 Jakub Bogusz <qboosh@pld-linux.org> 36ffa90
- updated to 1.11.1

* Fri May 20 2016 Jakub Bogusz <qboosh@pld-linux.org> b375e37
- updated to 1.10.0

* Mon May 16 2016 Elan Ruusamäe <glen@delfi.ee> 487c7a1
- icu-57.1 rebuild
- release 2 (by relup.sh)

* Thu Dec 24 2015 Jakub Bogusz <qboosh@pld-linux.org> af5f0d5
- updated to 1.6.0

* Mon Dec 14 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 21b412a
- up to 1.5.0

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 741cc55
- release 3 (by relup.sh)

* Sat Nov 14 2015 Jan Rękorajski <baggins@pld-linux.org> 397fce9
- release 2 (by relup.sh)

* Mon Sep 07 2015 Jakub Bogusz <qboosh@pld-linux.org> 7a45bd4
- updated to 1.3.0
- updated link patch
- added python patch (fixes install with destdir)

* Fri Jun 26 2015 Elan Ruusamäe <glen@delfi.ee> 7e35cf6
- update BR

* Thu Jun 25 2015 Jakub Bogusz <qboosh@pld-linux.org> 55ef14c
- updated to 1.0.4 (note: new soname)

* Sun Jun 07 2015 Elan Ruusamäe <glen@delfi.ee> 6d2042e
- boost rebuild
- release 2 (by relup.sh)

* Tue Mar 31 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 4a03938
- up to 0.7.9

* Fri Feb 27 2015 Jakub Bogusz <qboosh@pld-linux.org> 5ebd585
- updated to 0.7.5
- added link patch (libnghttp2_asio linking fix)
- build libnghttp2_asio

* Sun Sep 14 2014 Jakub Bogusz <qboosh@pld-linux.org> 593810f
- updated to 0.6.1 (note: new soname)

* Sat Jul 19 2014 Jakub Bogusz <qboosh@pld-linux.org> c02473f
- updated to 0.5.0 (note: new soname)

* Fri May 23 2014 Jakub Bogusz <qboosh@pld-linux.org> 2fcd397
- updated to 0.4.0

* Mon Mar 31 2014 Jakub Bogusz <qboosh@pld-linux.org> 90ff5ae
- updated to 0.3.2 release
- removed obsolete test patch
- added python binding

